<script setup lang="ts">
import { useRouter } from 'vue-router'
import type { ExposedForm } from '~/types/form'
import Action from '~/components/pub/my-ui/nav-footer/ba-dr-su.vue'
import { toast } from '~/components/pub/ui/toast'
import Confirmation from '~/components/pub/my-ui/confirmation/confirmation.vue'
import { TherapyProtocolMedicRehabilitationSchema, TherapyProtocolSchema } from '~/schemas/therapy-protocol.schema'
import { handleActionSave } from '~/handlers/therapy-protocol.handler'

// #region Props & Emits
const props = defineProps<{
  callbackUrl?: string
}>()

// form related state
const route = useRoute()
const encounterId = typeof route.params.id == 'string' ? parseInt(route.params.id) : 0
const inputForm = ref<ExposedForm<any> | null>(null)
// #endregion

// #region State & Computed
const router = useRouter()
const isConfirmationOpen = ref(false)
// #endregion

// #region Lifecycle Hooks
// #endregion

// #region Functions
function goBack() {
  router.go(-1)
}

async function handleConfirmAdd() {
  const inputData: any = await composeFormData()
  const response = await handleActionSave(
    inputData,
    () => { },
    () => { },
    toast,
  )

  const data = (response?.body?.data ?? null)
  if (!data) return
  goBack()
}

async function composeFormData(): Promise<any> {
  const [input,] = await Promise.all([
    inputForm.value?.validate(),
  ])

  const results = [input]
  const allValid = results.every((r) => r?.valid)

  // exit, if form errors happend during validation
  if (!allValid) return Promise.reject('Form validation failed')

  const formData = input?.values
  formData.medicalDiagnoses = JSON.stringify(formData.medicalDiagnoses)
  formData.functionDiagnoses = JSON.stringify(formData.functionDiagnoses)
  formData.procedures = JSON.stringify(formData.procedures)
  formData.encounter_id = encounterId

  return new Promise((resolve) => resolve(formData))
}
// #endregion region

// #region Utilities & event handlers
async function handleActionClick(eventType: string) {
  if (eventType === 'submit') {
    isConfirmationOpen.value = true
  }

  if (eventType === 'back') {
    if (props.callbackUrl) return navigateTo(props.callbackUrl)
    goBack()
  }
}

function handleCancelAdd() {
  isConfirmationOpen.value = false
}
// #endregion

// #region Watchers
// #endregion
const initial = {
  // Required String Fields
  form1ExaminationDate: "2025-11-06",
  form1Diagnose: 'Awwww',
  form1TherapyRequest: 'Awwww',
  form1TargetPeriod: 4,
  form1TherapyTarget: 'Awwww',
  form2RelationshipToInsured: 'child',
  anamnesis: 'Bobo aja wak',
  form2PhysicalExamination: 'Awwww',
  medicalDiagnoses: [
      {
          id: 3,
          code: "PROC002",
          name: "Cesarean section"
      }
  ],
  functionDiagnoses: [
      {
          id: 3,
          code: "PROC002",
          name: "Cesarean section"
      }
  ],
  procedures: [
      {
          id: 5,
          code: "PROC0100",
          name: "Physical therapy session"
      }
  ],
  supportingExams: 'Awwww',
  evaluation: 'Awwww',
  instruction: 'Awwww',
  workCauseStatus: 'TIDAK', 
  form3ExaminationDate: "2025-11-06",
  form3Diagnose: 'Awwww',
  form3TherapyRequest: 'Awwww',
  form3ProgramActivities: ['Menonton Kakek Meninggoy',],
}
</script>

<template>
  <div class="mb-5 border-b border-b-slate-300 pb-3 text-lg font-semibold xl:text-xl">Tambah</div>
  <AppTherapyProtocolEntry
    ref="inputForm"
    :schema="TherapyProtocolMedicRehabilitationSchema"
    :resume-arrangement-type="inputForm?.values.arrangement"
    :initial-values="initial"
  />
  
  <div class="my-2 flex justify-end py-2">
    <Action :enable-draft="false"
      @click="handleActionClick"/>
  </div>

  <Confirmation
    v-model:open="isConfirmationOpen"
    title="Simpan Data"
    message="Apakah Anda yakin ingin menyimpan data ini?"
    confirm-text="Simpan"
    @confirm="handleConfirmAdd"
    @cancel="handleCancelAdd"
  />
</template>
